diff --git a/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/pbist_utils.h b/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/pbist_utils.h
old mode 100755
new mode 100644
index b30a8f78728d1c42670ddd7be86dbad401608d8f..7a805f8369f2c0b910faab7260aed267e179cdb6
--- a/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/pbist_utils.h
+++ b/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/pbist_utils.h
@@ -67,7 +67,10 @@
 /* ========================================================================== */
 /*                             Include Files                                  */
 /* ========================================================================== */
-/* None */
+
+#include <stdint.h>
+#include <string.h>
+#include <sdl_types.h>
 
 /* ========================================================================== */
 /*                           Macros & Typedefs                                */
@@ -79,7 +82,8 @@
 /* ========================================================================== */
 /*                          Function Declarations                             */
 /* ========================================================================== */
+int32_t PBIST_clecConfig(uint32_t instance);
 int32_t PBIST_commonInit(void);
-int32_t PBIST_runTest(uint32_t instanceId);
+int32_t PBIST_runTest(uint32_t instanceId, bool runNegTest);
 
 #endif /* PBIST_UTILS_H_ */
diff --git a/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/power_seq.c b/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/power_seq.c
old mode 100755
new mode 100644
index ffe8d2b316c7876f2b96dba90f44b2119f6a8533..78846038d7499268dcc11ffe03eba45052257b40
--- a/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/power_seq.c
+++ b/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/power_seq.c
@@ -71,12 +71,15 @@
 /*                             Include Files                                  */
 /* ========================================================================== */
 
-#include "Std_Types.h"
-#include <ti/csl/csl_types.h>
-#include "boot_cfg.h"
+#include <stdint.h>
+#include <sdl_types.h>
+#include <ti/drv/uart/UART_stdio.h>
+#include <ti/drv/sciclient/sciclient.h>
+
+#ifdef SOC_J721E
 #include "armv8_power_utils.h"
-#include "app_utils.h"
 #include "power_seq.h"
+#endif
 
 /* ========================================================================== */
 /*                           Macros & Typedefs                                */
@@ -122,16 +125,17 @@
  * needed prior to powering up, outside of device/power domain controls */
 int32_t customPrepareForPowerUpSequence(uint8_t processorId)
 {
-    int32_t status = CSL_EFAIL;
+    int32_t status = SDL_EFAIL;
 
     switch(processorId)
     {
+#ifdef SOC_J721E
         case (SCICLIENT_PROC_ID_A72SS0_CORE0):
             status = armv8_powerPrepareForPowerUpSequence(processorId);
             break;
+#endif
         default:
-            AppUtils_Printf(MSG_NORMAL,
-                            "customPrepareForPowerUpSequence - Invalid ProcId %d\n",
+            UART_printf("customPrepareForPowerUpSequence - Invalid ProcId %d\n",
                             processorId);
             break;
     }
@@ -143,20 +147,20 @@ int32_t customPrepareForPowerUpSequence(uint8_t processorId)
  * needed to be properly powered down, outside of device/power domain controls */
 int32_t customPowerDownSequence(uint8_t processorId)
 {
-    int32_t status = CSL_EFAIL;
+    int32_t status = SDL_EFAIL;
 
     switch(processorId)
     {
+#ifdef SOC_J721E
         case (SCICLIENT_PROC_ID_A72SS0_CORE0):
             status = armv8_powerDownSequence(processorId);
             break;
+#endif
         default:
-            AppUtils_Printf(MSG_NORMAL,
-                            "customPowerDownSequence - Invalid ProcId %d\n",
+            UART_printf("customPowerDownSequence - Invalid ProcId %d\n",
                             processorId);
             break;
     }
 
     return (status);
 }
-
diff --git a/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j7200/armv8_power_utils.c b/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j7200/armv8_power_utils.c
index 97b159e0289218ad91c38f807233e1a9bc34f3d6..c4fc39c52517a4e41785f231a289218675bc501e 100644
--- a/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j7200/armv8_power_utils.c
+++ b/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j7200/armv8_power_utils.c
@@ -74,7 +74,7 @@
 
 #include <ti/drv/sciclient/sciclient.h>
 
-#include "app_utils.h"
+//#include "app_utils.h"
 
 /* ========================================================================== */
 /*                           Macros & Typedefs                                */
diff --git a/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j721e/armv8_power_utils.c b/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j721e/armv8_power_utils.c
index 97b159e0289218ad91c38f807233e1a9bc34f3d6..63afe311235088dfd750b57c883188bbd153c2df 100644
--- a/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j721e/armv8_power_utils.c
+++ b/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j721e/armv8_power_utils.c
@@ -69,13 +69,12 @@
 /* ========================================================================== */
 /*                             Include Files                                  */
 /* ========================================================================== */
-#include "Std_Types.h"
-#include <ti/csl/csl_types.h>
+#include <stdint.h>
+#include <sdl_types.h>
+#include <ti/drv/uart/UART_stdio.h>
 
 #include <ti/drv/sciclient/sciclient.h>
 
-#include "app_utils.h"
-
 /* ========================================================================== */
 /*                           Macros & Typedefs                                */
 /* ========================================================================== */
@@ -105,85 +104,77 @@
  * 5. Assert ACINACTM (to idle the AXI master interface)
  * 6. Wait for STANDBY_WFI_L2 (STANDBYWFIL2) bit to be asserted
  */
-// TODO - OPTIMIZE TIMING
 int32_t armv8_powerDownSequence(uint8_t processorId)
 {
-    int32_t status = CSL_EFAIL;
+    int32_t status = SDL_EFAIL;
 
 #ifdef DEBUG
-    AppUtils_Printf(APP_UTILS_PRINT_MSG_NORMAL,
-                    "  Running custom powerdown sequence for ARMv8 core\n");
+    UART_printf("  Running custom powerdown sequence for ARMv8 core\n");
 #endif
 
     /* Assert AINACTS first (to idle the ACP) - Set Bit 1 to 1 for asserting AINACTS */
     status = Sciclient_procBootSetSequenceCtrl(processorId, 0x00000002, 0x0, 0,
                                                SCICLIENT_SERVICE_WAIT_FOREVER);
-    if (status != CSL_PASS)
+    if (status != SDL_PASS)
     {
-        AppUtils_Printf(APP_UTILS_PRINT_MSG_NORMAL,
-                        "Sciclient_procBootSetSequenceCtrl...FAILED for AINACTS assert\n");
+        UART_printf("Sciclient_procBootSetSequenceCtrl...FAILED for AINACTS assert\n");
     }
 
     /* Assert L2FLUSHREQ - Set Bit 8 to 1 for asserting L2FLUSHREQ */
-    if (status == CSL_PASS) {
+    if (status == SDL_PASS) {
         status = Sciclient_procBootSetSequenceCtrl(processorId, 0x00000100, 0x0, 0,
                                                    SCICLIENT_SERVICE_WAIT_FOREVER);
-        if (status != CSL_PASS)
+        if (status != SDL_PASS)
         {
-            AppUtils_Printf(APP_UTILS_PRINT_MSG_NORMAL,
-                            "Sciclient_procBootSetSequenceCtrl...FAILED for " \
-                            "L2FLUSHREQ assert/set\n");
+            UART_printf("Sciclient_procBootSetSequenceCtrl...FAILED for " \
+                        "L2FLUSHREQ assert/set\n");
         }
     }
     /* Check L2FLUSH_DONE has been asserted - Ensure that Bit 4 has been set to 1 */
-    if (status == CSL_PASS) {
+    if (status == SDL_PASS) {
 
         status = Sciclient_procBootWaitProcessorState(processorId, 1, 1,
                                                       0x00000010, 0x0,
                                                       0x0, 0x0, 0,
                                                       SCICLIENT_SERVICE_WAIT_FOREVER);
-        if (status != CSL_PASS)
+        if (status != SDL_PASS)
         {
-            AppUtils_Printf(APP_UTILS_PRINT_MSG_NORMAL,
-                            "Sciclient_procBootWaitProcessorState...FAILED for " \
-                            "L2FLUSH_DONE set\n");
+            UART_printf("Sciclient_procBootWaitProcessorState...FAILED for " \
+                        "L2FLUSH_DONE set\n");
         }
     }
     /* Deassert L2FLUSHREQ - Clear Bit 8 to 0 for deasserting L2FLUSHREQ */
-    if (status == CSL_PASS) {
+    if (status == SDL_PASS) {
         status = Sciclient_procBootSetSequenceCtrl(processorId, 0x0, 0x00000100, 0,
                                                    SCICLIENT_SERVICE_WAIT_FOREVER);
-        if (status != CSL_PASS)
+        if (status != SDL_PASS)
         {
-            AppUtils_Printf(APP_UTILS_PRINT_MSG_NORMAL,
-                            "Sciclient_procBootSetSequenceCtrl...FAILED for " \
-                            "L2FLUSHREQ deassert/clear\n");
+            UART_printf("Sciclient_procBootSetSequenceCtrl...FAILED for " \
+                        "L2FLUSHREQ deassert/clear\n");
         }
     }
 
     /* Check L2FLUSH_DONE has been deasserted - Ensure that Bit 4 has been cleared to 0 */
-    if (status == CSL_PASS) {
+    if (status == SDL_PASS) {
 
         status = Sciclient_procBootWaitProcessorState(processorId, 1, 1,
                                                       0x0, 0x0,
                                                       0x00000010, 0x0, 0,
                                                       SCICLIENT_SERVICE_WAIT_FOREVER);
-        if (status != CSL_PASS)
+        if (status != SDL_PASS)
         {
-            AppUtils_Printf(APP_UTILS_PRINT_MSG_NORMAL,
-                            "Sciclient_procBootWaitProcessorState...FAILED for " \
-                            "L2FLUSH_DONE clear \n");
+            UART_printf("Sciclient_procBootWaitProcessorState...FAILED for " \
+                        "L2FLUSH_DONE clear \n");
         }
     }
     /* Assert ACINACTM (to idle the AXI master interface) - Set Bit 0 to 1 for asserting ACINACTM */
-    if (status == CSL_PASS) {
+    if (status == SDL_PASS) {
         status = Sciclient_procBootSetSequenceCtrl(processorId, 0x00000001, 0x0, 0,
                                                    SCICLIENT_SERVICE_WAIT_FOREVER);
-        if (status != CSL_PASS)
+        if (status != SDL_PASS)
         {
-            AppUtils_Printf(APP_UTILS_PRINT_MSG_NORMAL,
-                            "Sciclient_procBootSetSequenceCtrl...FAILED for " \
-                            "ACINACTM assert/set \n");
+            UART_printf("Sciclient_procBootSetSequenceCtrl...FAILED for " \
+                        "ACINACTM assert/set \n");
         }
     }
 
@@ -201,43 +192,39 @@ int32_t armv8_powerDownSequence(uint8_t processorId)
  */
 int32_t armv8_powerPrepareForPowerUpSequence(uint8_t processorId)
 {
-    int32_t status = CSL_EFAIL;
+    int32_t status = SDL_EFAIL;
 
 #ifdef DEBUG
-    AppUtils_Printf(APP_UTILS_PRINT_MSG_NORMAL,
-                    "  Running custom power restore sequence for ARMv8 core\n");
+    UART_printf("  Running custom power restore sequence for ARMv8 core\n");
 #endif
 
     /* Deassert L2FLUSHREQ - Clear Bit 8 to 0 for deasserting L2FLUSHREQ */
-    if (status == CSL_PASS) {
+    if (status == SDL_PASS) {
         status = Sciclient_procBootSetSequenceCtrl(processorId, 0x0, 0x00000100, 0,
                                                    SCICLIENT_SERVICE_WAIT_FOREVER);
-        if (status != CSL_PASS)
+        if (status != SDL_PASS)
         {
-            AppUtils_Printf(APP_UTILS_PRINT_MSG_NORMAL,
-                            "Sciclient_procBootSetSequenceCtrl...FAILED for " \
-                            "L2FLUSHREQ deassert/clear\n");
+            UART_printf("Sciclient_procBootSetSequenceCtrl...FAILED for " \
+                        "L2FLUSHREQ deassert/clear\n");
         }
     }
     /* Deassert AINACTS  - Clear Bit 1 to 0 for deasserting AINACTS */
     status = Sciclient_procBootSetSequenceCtrl(processorId, 0x0, 0x00000002, 0,
                                                SCICLIENT_SERVICE_WAIT_FOREVER);
-    if (status != CSL_PASS)
+    if (status != SDL_PASS)
     {
-        AppUtils_Printf(APP_UTILS_PRINT_MSG_NORMAL,
-                        "Sciclient_procBootSetSequenceCtrl...FAILED for AINACTS " \
-                        "deassert\n");
+        UART_printf("Sciclient_procBootSetSequenceCtrl...FAILED for AINACTS " \
+                    "deassert\n");
     }
 
     /* Deassert ACINACTM - Clear Bit 0 to 0 for deasserting ACINACTM */
-    if (status == CSL_PASS) {
+    if (status == SDL_PASS) {
         status = Sciclient_procBootSetSequenceCtrl(processorId, 0x0, 0x00000001, 0,
                                                    SCICLIENT_SERVICE_WAIT_FOREVER);
-        if (status != CSL_PASS)
+        if (status != SDL_PASS)
         {
-            AppUtils_Printf(APP_UTILS_PRINT_MSG_NORMAL,
-                            "Sciclient_procBootSetSequenceCtrl...FAILED for " \
-                            "ACINACTM deassert/clear \n");
+            UART_printf("Sciclient_procBootSetSequenceCtrl...FAILED for " \
+                        "ACINACTM deassert/clear \n");
         }
     }
 
diff --git a/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j721e/bist_core_defs.c b/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j721e/bist_core_defs.c
index e9363ec2dffb096c9104666f3c74d31c6d25b724..9f8fc8dcae133b0063e693620b81ee6032b8e400 100644
--- a/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j721e/bist_core_defs.c
+++ b/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j721e/bist_core_defs.c
@@ -70,7 +70,6 @@
 /* ========================================================================== */
 #include <stdint.h>
 #include "bist_core_defs.h"
-#include "boot_stage_defs.h"
 
 /* ========================================================================== */
 /*                           Macros & Typedefs                                */
@@ -106,14 +105,23 @@
  * boot sequence for J721E SOC */
 int pbist_pre_boot_stage[] =
 {
+    PBIST_HWPOST_MCU_INDEX,    /* Read results of HW POST MCU PBIST */
     PBIST_INSTANCE_MAIN_INFRA, /* Main Infra - Must be in pre-boot stage */
-    PBIST_INSTANCE_MSMC        /* MSMC RAM - Must be in pre-boot stage */
+//    PBIST_INSTANCE_MSMC        /* MSMC RAM - Must be in pre-boot stage */
 };
 
 int pbist_pre_boot_stage_status[] =
 {
-    0,  /* MCU */
-    0   /* NAVSS */
+    0,  /* HW Post status */
+    0,  /* Main Infra */
+    0   /* MSMC */
+};
+
+int pbist_pre_boot_stage_neg_status[] =
+{
+    0,  /* HW Post status */
+    0,  /* Main Infra */
+    0   /* MSMC */
 };
 
 /* Defines LBIST's needed for all cores before the first stage of the Main Domain
@@ -172,8 +180,6 @@ int lbist_second_boot_stage[] =
 int pbist_third_boot_stage[] =
 {
     PBIST_INSTANCE_A72,      /* A72 */
-    PBIST_INSTANCE_HC,       /* HC - MLB PBIST */
-    PBIST_INSTANCE_ENCODER   /* Encoder */
 };
 
 
@@ -225,6 +231,9 @@ const char *pbistName(uint32_t pbistID)
 
     switch(pbistID)
     {
+        case (PBIST_HWPOST_MCU_INDEX):
+            name="PBIST_HWPOST_MCU_INDEX";
+            break;
         case (PBIST_INSTANCE_MCU):
             name="PBIST_INSTANCE_MCU";
             break;
@@ -267,6 +276,9 @@ const char *pbistName(uint32_t pbistID)
         case (PBIST_INSTANCE_ENCODER):
             name="PBIST_INSTANCE_ENCODER";
             break;
+	case (PBIST_INSTANCE_DECODER):
+            name="PBIST_INSTANCE_DECODER";
+            break;
         default:
             name="INVALID ID";
             break;
diff --git a/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j721e/bist_core_defs.h b/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j721e/bist_core_defs.h
index ca5c5edaa7cf822e289168438de9818a8bbabdb5..6f547c5222c1d287175ac5b9ec99ddffbe827807 100644
--- a/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j721e/bist_core_defs.h
+++ b/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j721e/bist_core_defs.h
@@ -42,29 +42,35 @@ extern "C"
 /* ========================================================================== */
 /*                             Include Files                                  */
 /* ========================================================================== */
-#include "boot_stage_defs.h"
+
+/* None */
 
 /* ========================================================================== */
 /*                           Macros & Typedefs                                */
 /* ========================================================================== */
-#define PBIST_INSTANCE_MCU                (0U) // Not supported in BootApp
-#define PBIST_INSTANCE_MAIN_PULSAR_0      (1U)
-#define PBIST_INSTANCE_MAIN_PULSAR_1      (2U)
-#define PBIST_INSTANCE_C7X                (3U)
-#define PBIST_INSTANCE_A72                (4U)
-#define PBIST_INSTANCE_VPAC               (5U)
-#define PBIST_INSTANCE_DMPAC              (6U)
-#define PBIST_INSTANCE_MAIN_NAVSS         (7U)
-#define PBIST_INSTANCE_HC                 (8U)
-#define PBIST_INSTANCE_C66X_0             (9U)
-#define PBIST_INSTANCE_C66X_1             (10U)
-#define PBIST_INSTANCE_MAIN_INFRA         (11U)
-#define PBIST_INSTANCE_MSMC               (12U)
-#define PBIST_INSTANCE_ENCODER            (13U) // Not supported in BootApp
-#define PBIST_INSTANCE_DECODER            (14U) // Not supported in BootApp
-#define PBIST_INSTANCE_GPU                (15U) // Not supported in BootApp
-#define PBIST_INSTANCE_DSS_EDP_DSI        (16U) // Not supported in BootApp
-#define PBIST_INSTANCE_MCU_PULSAR         (17U) // Not supported in BootApp
+/* Defines total number of Boot Stages for the Main Domain
+ * multi-stage boot sequence for J721E SOC */
+#define NUM_BOOT_STAGES     3
+
+#define PBIST_HWPOST_MCU_INDEX            (0U)
+#define PBIST_INSTANCE_MCU                (1U) // Not supported in example 
+#define PBIST_INSTANCE_MAIN_PULSAR_0      (2U)
+#define PBIST_INSTANCE_MAIN_PULSAR_1      (3U)
+#define PBIST_INSTANCE_C7X                (4U)
+#define PBIST_INSTANCE_A72                (5U)
+#define PBIST_INSTANCE_VPAC               (6U)
+#define PBIST_INSTANCE_DMPAC              (7U)
+#define PBIST_INSTANCE_MAIN_NAVSS         (8U)
+#define PBIST_INSTANCE_HC                 (9U)
+#define PBIST_INSTANCE_C66X_0             (10U)
+#define PBIST_INSTANCE_C66X_1             (11U)
+#define PBIST_INSTANCE_MAIN_INFRA         (12U)
+#define PBIST_INSTANCE_MSMC               (13U)
+#define PBIST_INSTANCE_ENCODER            (14U)
+#define PBIST_INSTANCE_DECODER            (15U)
+#define PBIST_INSTANCE_GPU                (16U) // Not supported in BootApp
+#define PBIST_INSTANCE_DSS_EDP_DSI        (17U) // Not supported in BootApp
+#define PBIST_INSTANCE_MCU_PULSAR         (18U) // Not supported in BootApp
 
 #define PBIST_MAX_INSTANCE                (PBIST_INSTANCE_MCU_PULSAR+1U)
 
@@ -101,6 +107,9 @@ extern int pbist_pre_boot_stage[];
 /* Structure to save the status of the PBIST tests run as part of the pre-boot stage */
 extern int pbist_pre_boot_stage_status[];
 
+/* Structure to save the status of the PBIST negative tests run as part of the pre-boot stage */
+extern int pbist_pre_boot_stage_neg_status[];
+
 /* Number of LBIST tests run in the pre-boot stage, i.e. before any Main Domain
  * cores are booted */
 extern int lbist_pre_boot_stage[];
